OpenShot Audio Library | OpenShotAudio: juce::IIRFilterAudioSource Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::IIRFilterAudioSource Class Reference

`#include <juce_IIRFilterAudioSource.h>`

Inheritance diagram for juce::IIRFilterAudioSource:

## Public Member Functions
| IIRFilterAudioSource (AudioSource *inputSource, bool deleteInputWhenDeleted)
| ~IIRFilterAudioSource () override
void | setCoefficients (const IIRCoefficients &newCoefficients)
void | makeInactive ()
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
void | releaseResources () override
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
Public Member Functions inherited from juce::AudioSource
virtual | ~AudioSource ()=default
virtual void | prepareToPlay (int samplesPerBlockExpected, double sampleRate)=0
virtual void | releaseResources ()=0
virtual void | getNextAudioBlock (const AudioSourceChannelInfo &bufferToFill)=0

## Additional Inherited Members
Protected Member Functions inherited from juce::AudioSource
| AudioSource ()=default

## Detailed Description

An AudioSource that performs an IIR filter on another source.

Definition at line 32 of file juce_IIRFilterAudioSource.h.

## Constructor & Destructor Documentation

## ◆ IIRFilterAudioSource()

juce::IIRFilterAudioSource::IIRFilterAudioSource | ( | AudioSource * | inputSource,
|  | bool | deleteInputWhenDeleted
| ) |  |

Creates a IIRFilterAudioSource for a given input source.

Parameters

  inputSource | the input source to read from - this must not be null
  deleteInputWhenDeleted | if true, the input source will be deleted when this object is deleted

Definition at line 26 of file juce_IIRFilterAudioSource.cpp.

## ◆ ~IIRFilterAudioSource()

juce::IIRFilterAudioSource::~IIRFilterAudioSource | ( |  | ) |
| override

Destructor.

Definition at line 36 of file juce_IIRFilterAudioSource.cpp.

## Member Function Documentation

## ◆ getNextAudioBlock()

void juce::IIRFilterAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |
| overridevirtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements juce::AudioSource.

Definition at line 65 of file juce_IIRFilterAudioSource.cpp.

## ◆ makeInactive()

void juce::IIRFilterAudioSource::makeInactive | ( |  | ) |

Calls IIRFilter::makeInactive() on all the filters being used internally.

Definition at line 45 of file juce_IIRFilterAudioSource.cpp.

## ◆ prepareToPlay()

void juce::IIRFilterAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate
| ) |  |
| overridevirtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 52 of file juce_IIRFilterAudioSource.cpp.

## ◆ releaseResources()

void juce::IIRFilterAudioSource::releaseResources | ( |  | ) |
| overridevirtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 60 of file juce_IIRFilterAudioSource.cpp.

## ◆ setCoefficients()

void juce::IIRFilterAudioSource::setCoefficients | ( | const IIRCoefficients & | newCoefficients | ) |

Changes the filter to use the same parameters as the one being passed in.

Definition at line 39 of file juce_IIRFilterAudioSource.cpp.

The documentation for this class was generated from the following files:

- juce_IIRFilterAudioSource.h
- juce_IIRFilterAudioSource.cpp